dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/perks/perk.lua")

pickup = ModSettingGet("random_starting_wand.pickup")

function time_seed()
	if ModSettingGet("random_starting_wand.time_seeded") then
		local out = Randomf(-3,3)
		print(out)
		return out
	else
		return 0
	end
end

function OnPlayerSpawned( player_entity ) -- This runs when player entity has been created

	local flag = "randomstarterwandsgiven"
	
	if GlobalsGetValue(flag, "0") == "1" then return end
	
	local playtime = StatsGetValue("playtime")
	
	if tonumber(playtime) > 5 then
		GlobalsSetValue(flag, "1")
		return
	end
	
	-- time seed
	local Y,M,D,h,m,s = GameGetDateAndTimeLocal()
	SetRandomSeed(Y+M+D, h+m+s)
	
	local x,y = EntityGetTransform( player_entity )
	
	-- clear inv
	
	if ModSettingGet("random_starting_wand.give_random_wands") then
		local inventory = nil

		-- find the quick inventory, player cape and arm
		local player_child_entities = EntityGetAllChildren( player_entity )
		if ( player_child_entities ~= nil ) then
			for i,child_entity in ipairs( player_child_entities ) do
				local child_entity_name = EntityGetName( child_entity )
				if ( child_entity_name == "inventory_quick" ) then
					inventory = child_entity
				end
			end
		end
		
			-- set inventory contents
		if ( inventory ~= nil ) then
			local inventory_items = EntityGetAllChildren( inventory )
			
			-- remove default items
			if inventory_items ~= nil then
				for i,item_entity in ipairs( inventory_items ) do
					GameKillInventoryItem( player_entity, item_entity )
				end
			end
		end
	end
	
	-- grant stuff		
	
	-- wands
	
	local i = 1
	while i <= 4 do
		local wand_type = ModSettingGet("random_starting_wand.wand_type_" .. i)
		local wand
		
		if wand_type == "tiered" then
			local tier = ModSettingGet("random_starting_wand.wand_tier_" .. i)
			
			wand = EntityLoad("mods/random_starting_wand/files/tiered_wand" .. i .. ".xml", x+i*10-25+time_seed(), y-10+time_seed())
		elseif wand_type == "handgun" then
			wand = EntityLoad("data/entities/items/starting_wand_rng.xml", x+i*10-25+time_seed(), y-10+time_seed())
		elseif wand_type == "bomb" then
			wand = EntityLoad("data/entities/items/starting_bomb_wand_rng.xml", x+i*10-25+time_seed(), y-10+time_seed())
		end
		
		if pickup and wand ~= nil then
			GamePickUpInventoryItem(player_entity, wand, false)
		end
		i = i+1
	end
	-- potion
	
	grant_potions(tonumber(ModSettingGet("random_starting_wand.potion_amount")), x, y, player_entity)
	
	--EntityLoad("data/entities/items/pickup/wandstone.xml",x, y)
	
	-- spells and perks
	
	grant_spells(tonumber(ModSettingGet("random_starting_wand.starting_spell_count")), x, y, player_entity)
	grant_perks(tonumber(ModSettingGet("random_starting_wand.random_perk_count")), x, y, player_entity)
	
	-- wand tinker
	
	if ModSettingGet("random_starting_wand.wand_tinker") then
		EntityLoad("mods/random_starting_wand/files/workshop_allow_mods.xml",x,y)
	end
	
	GlobalsSetValue(flag, "1")
	
	-- i stole half this code from starter_loadouts default mod

end

function grant_potions(i, x, y, player_entity)
	GamePrint(i .. " Potions Given")
	local pot_type = ModSettingGet("random_starting_wand.potion_type")
	
	
	while i > 0 do
		local item = EntityLoad("data/entities/items/pickup/" .. pot_type, x+i*3+time_seed(), y+time_seed())
		
		if pickup then
			GamePickUpInventoryItem(player_entity, item)
		end
		i = i - 1
	end
end

function grant_spells(i, x, y, player_entity)
	GamePrint(i .. " Spells Given")
	local tier = ModSettingGet("random_starting_wand.spell_tier")
	while i > 0 do
		local item = CreateItemActionEntity(GetRandomAction( x-i*16+time_seed(), y+10+i+time_seed(), tier, 666), x-i*16, y)
		
		if pickup then
			GamePickUpInventoryItem(player_entity, item, false)
		end
		i = i - 1
	end
end

function grant_perks(i, x, y, player_entity)
	GamePrint(i .. " Perks Given")
	while i > 0 do
		local perk = perk_spawn_random(x+25, y-i*16+16, true)
		
		if pickup then
			perk_pickup(perk, player_entity, EntityGetName(perk), false, false)
		end
		i = i - 1
	end
end